#!/usr/local/bin/perl -w
use SOAP::Lite;
use LWP::UserAgent;

my $API_KEY = "8OyhJD1QFHKSUqCaHLXxC4Ih8gYeUkJN";

print "Content-type: text/html\n\n";


my $ua = LWP::UserAgent->new;
$ua->agent("Crawzilla");
$ua->timeout(10);

my %words = ();
my @common;



$contentlength = $ENV{'CONTENT_LENGTH'};
read(STDIN,$buffer,$contentlength);

	# Split the name-value pairs 
	@pairs = split(/&/, $buffer); 

	foreach $pair (@pairs) { 
	($name, $value) = split(/=/, $pair); 

	$value =~ tr/+/ /; 
	$value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg; 
	$name =~ tr/+/ /; 
	$name =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg; 

	$FORM{$name} = $value; 
}   

############################################################################

sub getLinks {
	
	# Purpose: get the links returned from Google for a particular query

	my $service = SOAP::Lite->service('file:GoogleSearch.wsdl');
	
	#print $result->{estimatedTotalResultsCount};
	
	my @links;
	
	my $result = $service->doGoogleSearch($API_KEY,$_[0],0,10,"false","","false","","","");

	foreach $temp (@{$result->{resultElements}}) {
		push(@links,$temp->{URL});
	} # for each URL
	
	return @links;
	
} # getLinks

############################################################################

sub getLiveContent {

	# parameters: $_[0] = URL to get
	
	my $buffer = "";
	
	my $res = $ua->request(HTTP::Request->new(GET => $_[0]),
	
	sub {
 		my($chunk, $res) = @_;
 		$buffer .= $chunk;
	});
 
	return $buffer;

} # getLiveContent

############################################################################

sub removeHTML {

	my $b = lc($_[0]);
	
	$b =~ s/\s+/ /igs;
	
	$b =~ s/&.+?;//g;
	$b =~ s/<script.+?script>//g;
	$b =~ s/<style.+?style>//g;
	$b =~ s/<button.+?button>//g;
	$b =~ s/<.+?>//g;
	$b =~ s/[^a-zA-Z ]//g;

	return $b;
}

############################################################################


sub getWords {
		
my @links = getLinks($_[0]);

for my $i(0..$#links) {
	
	my $content = removeHTML(getLiveContent($links[$i]));
	
	# split on whitespace
	my @temp = split(/\s+/,$content);

	# for each word, update its frequency...
	for my $x(0..$#temp) { $words{lc($temp[$x])}++; }
	
}

} # getWords



#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# read in the driver file
#my $file_content = 

my @temp;

for my $i(1..3) {
  if (length($FORM{"txtBootstrap" . $i}) > 0) { push(@temp,$FORM{"txtBootstrap" . $i}); }
}

# split the file content on new line chars
#my @temp = split( /\n/, $file_content);

# surround each search term with quotes
for my $i(0..$#temp) { $temp[$i] = "\"" . $temp[$i] . "\""; }

# get words for each search term (with the topic)
for my $i(0..$#temp) { getWords("\"" . $FORM{"txtTopic"} . "\" " . $temp[$i]); }
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~


#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# read in the file containing common english words
my @common;

open(FILE, "common.txt");

while (<FILE>) {

	# remove newline char
	chomp;
	
	# trim
	$_ =~ s/^\s+//;
	$_ =~ s/\s+$//;
	
	# split on whitespace
	my @temp = split(/\s+/,$_);
	
	# store words from this line into the hash table
	for my $i(0..$#temp) { push(@common,lc($temp[$i])); }

}

close FILE;

# delete each common word from the hash table (if it exists)
for my $i(0..$#common) { delete $words{lc($common[$i])}; }


#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

# delete words that are too long or too short
while ( my ($key, $value) = each(%words) ) {
	
  if (  length($key) < 3 || length($key) > 12 ) { delete $words{$key}; }
  
  if ($words{$key} < 5) { delete $words{$key}; }
  
  
    }

    
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# determine the new ad file name
my $i = 1;
while ( -e "ads/ad$i.txt" ) { $i++; }
$filename = "ad$i";
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

# print the contents of the hash table in DESC order
open (ADFILE, ">ads/$filename.txt") or die "oops";

print ADFILE "{TITLE}\n" . $FORM{"txtTitle"};
print ADFILE "\n{DESCRIPTION}\n" . $FORM{"txtDescription"};
print ADFILE "\n{KEYWORDS}\n";
foreach $w (sort {$words{$b} <=> $words{$a}} keys %words)
  { print ADFILE $words{$w} . " " . $w . "\n"; } 
  
close (ADFILE); 

print "Ad generation complete.  Click <A HREF=viewad.cgi?id=$filename>here</A> to view the results.";