#!/usr/local/bin/perl
print "Content-type: text/html\n\n";


#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# get everything from the HTML FORM that 
# submitted information to this
# script and store it in a hash table

$contentlength = $ENV{'CONTENT_LENGTH'};
read(STDIN,$buffer,$contentlength);

	# Split the name-value pairs 
	@pairs = split(/&/, $buffer); 

	foreach $pair (@pairs) { 
	($name, $value) = split(/=/, $pair); 

	$value =~ tr/+/ /; 
	$value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg; 
	$name =~ tr/+/ /; 
	$name =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg; 

	$FORM{$name} = $value; 
}   
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# get everything from the QUERY_STRING 
# and store it in a hash table
@temp = split(/&/,$ENV{QUERY_STRING});

my %QUERYSTRING = ();

foreach(@temp) { 
	my @val = split(/=/);
 	$QUERYSTRING{$val[0]} = $val[1];
}
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# make sure the email file exists
if (!( -e "emails/$QUERYSTRING{'id'}.txt" ))
 { print "Invalid email ID."; exit; }
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# Determine the number of ads to display

my $max_ads;

if ( $QUERYSTRING{"adcount"}  ) 
 { $max_ads = $QUERYSTRING{"adcount"}; }
else 
 { $max_ads = 1; }
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# read in the email content
my $read = "";

open(FILE, "emails/$QUERYSTRING{'id'}.txt");
while (<FILE>) { $read .= $_; }
close FILE;

my @temp = split(/{BODY}/,$read);

my $subject = $temp[0];
   $subject =~ s/.*{SUBJECT}//igs;

my $body = $temp[1];
   $body =~ s/[^a-zA-Z ]//igs; # only need words
   $body = lc($body);
   
my $body_original = $temp[1]; # store for displaying


#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~


#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# build a hash table of words from the
# email body.  The values of the hash
# table are the frequencies of the words

my @body_words = split(/\s+/,$body);
my %words = ();

for $i(0..$#body_words) { $words{lc($body_words[$i])}++; }
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

###########################################################################
sub getAd {

	my $read = "";

	open(FILE, "ads/$_[0].txt");
	while (<FILE>) { $read .= $_; }
	close FILE;

	$title = $read;
	$description = $read;

	$description =~ s/.*{DESCRIPTION}//igs;
	$description =~ s/{KEYWORDS}.*//igs;

	$title =~ s/{TITLE}//igs;
	$title =~ s/{DESCRIPTION}.*//igs;
	
	my $ad = "";
	
	$ad = "<FONT STYLE=font-family:tahoma;font-size:10px;font-weight:bold;>ADVERTISEMENT</FONT><BR>";
   	$ad .= "<TABLE TITLE=\"Score: $_[1]\" BORDERCOLOR=BLACK BORDER=1 STYLE=border-collapse:collapse;background-color:lightyellow;font-family:verdana;font-size:11px;border-style:solid;border-width:1px;border-color:black;width:200px;><TR>";
   	$ad .= "<TD STYLE=padding:2mm;color:blue;text-decoration:underline;font-weight:bold; ALIGN=CENTER>$title</TD>";
   	$ad .= "</TR><TR><TD STYLE=padding:2mm;>$description";
   	
   	# display scoring analysis links
   	if ($QUERYSTRING{"score"} eq "true") { 
	   	$ad .= "<BR><BR><FONT STYLE=font-size:10px;><B>Score:</B> <FONT STYLE=color:blue;>$_[1]</FONT></FONT>"; 
   		$ad .= "<BR><FONT STYLE=font-size:10px;><A HREF=read.cgi?id=$QUERYSTRING{'id'}&score=true&highlight=$_[0]&adcount=$max_ads>Highlight</A> | <A HREF=javascript:getPopup('review.cgi?ad=$_[0]&email=$QUERYSTRING{'id'}');>Ad words</A></FONT>";
   	}
   	
   	$ad .= "</TD></TR></TABLE>";
   	   
   return $ad;
}


###########################################################################
sub getScore {
	
	my $total_score = 0;
	my %score = ();
	my $read = "";
	
	# read in the ad driver file
	open(FILE, "ads/$_[0].txt");
	while (<FILE>) { $read .= $_; }
	close FILE;

	# get rid of everything but the keywords
	$read =~ s/.*{KEYWORDS}//igs;

	# trim
	$read =~ s/^\s+//;
	$read =~ s/\s+$//;
	
	# split the remaining section on whitepsace
	my @ad_words = split(/\s+/,$read);
	
	# format for each line is "score keyword", so store each keyword
	# in a scoring hash table and use its score as the value
	for (my $i=0; $i<$#ad_words;$i+=2) 
	 { $score{lc($ad_words[$i+1])} = $ad_words[$i]; }
	
	# calculate the overall score for this ad driver against the words for this email
	my $w;
	foreach $w (sort {$words{$b} <=> $words{$a}} keys %words) { $total_score += ($words{$w} * $score{$w}); }

	
	#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	# highlight the keywords that were scored
 	if ( $QUERYSTRING{"highlight"} eq $_[0]) { 
	 foreach $w (sort {$score{$b} <=> $score{$a}} keys %score) { 
	  if ($body =~ /\b$w\b/igs) 
	    { $body_original =~ s/$w/<B TITLE=\"Score: $score{$w}\" STYLE=cursor:hand;><U>$w<\/U><\/B>/igs; }
	  }
 	}
	#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	
	return $total_score;
		
}
###########################################################################

# ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# read in all of the ad driver files in the "ads" directory
# and calculate the score of their keywords against the body
# of the current email

my %results = ();
my @scripts = glob("ads/*.txt");
for $i(0..$#scripts) {
	
	$scripts[$i] =~ s/.*\///ig;
	$scripts[$i] =~ s/\.txt//ig;
	$scripts[$i] =~ s/ad_//ig;
	
	my $score = getScore($scripts[$i]);
	$results{$scripts[$i]} = $score;
}
# ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

# ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# get the HTML to display for the specified number of ads
my $count = 0;
my $w;
my $ads = "";
foreach $w (sort {$results{$b} <=> $results{$a}} keys %results) { 
  $ads .= getAd($w,$results{$w}) . "<BR>";
  if (++$count == $max_ads) { last; }
}
# ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~


# ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# trim trailing/leading whitespace from body
$body_original =~ s/^\s+//;
$body_original =~ s/\s+$//;
 
# put in HTML line breaks for \n chars
$body_original =~ s/\n/<BR>/igs;
# ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 
# ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# read in the toolbar
my $toolbar = "";
open(TOOLBAR, "toolbar.txt"); 
while (<TOOLBAR>){ $toolbar .= $_;  } 
close TOOLBAR;
# ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

# display the page...
print <<EOF ;
<HTML>
<HEAD><TITLE>Read Email</TITLE>

<SCRIPT LANGUAGE=JavaScript>

	function getPopup(page){

		var h = 350;
		var w = 500;
		
		leftPos=(screen.width)?(screen.width-w)/2:100;
		topPos=(screen.height)?(screen.height-h)/2:100;

		settings='width='+w+',height='+h+',top='+topPos+',left='+leftPos+',scrollbars=yes,location=no,directories=no,status=no,menubar=no,toolbar=no,resizable=no';
		win=window.open(page,'win',settings);

	} // getPopup

</SCRIPT>


</HEAD>
<BODY>
$toolbar
<BR><BR>
<TABLE BORDER=0>
 <TR>
  <TD VALIGN=TOP WIDTH=70%>
  
  <TABLE BORDER=1 CELLSPACING=0 CELLPADDING=0 WIDTH=100% STYLE=font-family:verdana;font-size:11px;padding:3mm;>
   <TR>
    <TD STYLE=padding-bottom:2cm; VALIGN=TOP>
    <B>To:</B> you\@yourdomain.com<BR>
    <B>From:</B> me\@mydomain.com<BR>
    <B>Subject:</B> $subject
    <HR>
    $body_original
    </TD>
   </TR>
  </TABLE>
  
  </TD>
  <TD ROWSPAN=2 VALIGN=TOP ALIGN=CENTER>$ads
  
  
  <INPUT TYPE=BUTTON VALUE="View Scoring" STYLE=font-size:11px;font-family:verdana;background-color:#ececec;font-weight:bold; onClick=window.location='read.cgi?id=$QUERYSTRING{'id'}&score=true&adcount=$max_ads'\;>
  
  </TD>
 </TR>
</TABLE>
<HR STYLE=height:1px;>

</BODY></HTML>
EOF

exit ;

